/*
 * main.c
 * code: SASANO Takayoshi
 * --- public domain, no warranty
 */

#include "vdclient.h"

/* ꥢ */
LOCAL	DrvWork	*WorkArea[MAXDRIVE];

/* ɥ쥹֤ȥå */
EXPORT	ERR	taskspace_select(DevReq *q)
{
	ERR	err;

	if (!q->cmd.adcnv || q->datacnt <= 0) return ER_OK;

	D(5, ("taskspace_select: taskid %d memptr %x datacnt %d\n",
	      q->taskid, q->memptr, q->datacnt));

	/* ɥ쥹֤ */
	err = SetTaskSpace(q->taskid);
	if (err < ER_OK) {
		D(0, ("taskspace_select: SetTaskSpace %d\n", err));
		goto fin;
	}

	/* ɥ쥹֤Υå */
	err = (q->cmd.cmd == DC_READ) ?
		CheckSpaceRW(q->memptr, q->datacnt) :
		CheckSpaceR(q->memptr, q->datacnt);

	if (err < ER_OK) {
		D(0, ("taskspace_select: CheckSpaceR(W) %d\n", err));
	}

 fin:
	return err;
}

/* ɥ饤Сȥݥ */
EXPORT	ERR	main(Bool start, TC *arg)
{
	W	i, mbfid;
	ERR	err;

	if (!start) {
		err = ER_OK;
		goto fin3;
	}

	/* ѥåХåեID */
	mbfid = get_mbfid();
	D(3, ("main: mbfid: %d\n", mbfid));

	/* ꥢν */
	memset(WorkArea, 0, sizeof(WorkArea));
	for (i = 0; i < MAXDRIVE; i++) {
		WorkArea[i] = Kmalloc(sizeof(DrvWork));
		if (WorkArea[i] == NULL) {
			D(0, ("main: Kmalloc NULL\n"));
			err = ER_NOMEM;
			goto fin1;
		}
		memset(WorkArea[i], 0, sizeof(DrvWork));
		WorkArea[i]->drvno = i;
		WorkArea[i]->t_mbfid = mbfid;
	}

	/* ۥɥ饤ֽεư */
	for (i = 0; i < MAXDRIVE; i++) {
		err = vd_start(WorkArea[i]);
		if (err < ER_OK) goto fin2;
	}

	/* εư */
	for (i = 0; i < MAXDRIVE; i++) {
		err = ctl_start(WorkArea[i]);
		if (err < ER_OK) goto fin3;
	}

	err = ER_OK;
	goto fin0;


	/* ޤȤƤɤȤꤢ̤˽λ */
 fin3:
	for (i = 0; i < MAXDRIVE; i++) {
		if (WorkArea[i] != NULL) ctl_finish(WorkArea[i]);
	}
 fin2:
	for (i = 0; i < MAXDRIVE; i++) {
		if (WorkArea[i] != NULL) vd_finish(WorkArea[i]);
	}
 fin1:
	for (i = 0; i < MAXDRIVE; i++) {
		if (WorkArea[i] != NULL) Kfree(WorkArea[i]);
	}
 fin0:
	return err;
}
