/*
 * vdclient.h
 * original code: SASANO Takayoshi
 * --- public domain, no warranty.
 */

#include <driver/driver.h>
#include <device/disk.h>
#include <kernel/util.h>
#include <inner.h>
#include <tcode.h>
#include <errcode.h>
#include "vdctl.h"	/*  */

#ifdef	DEBUG
#define	MESSAGE_LEVEL	4
#define	D(l, x)	if ((l) <= MESSAGE_LEVEL) printf x
#else
#define	D(l, x)	/* */
#endif

typedef	struct	_drvwork {
	W		drvno;

	/* vddrv */
	ID		t_devid;
	ID		t_mbfid;
	ID		t_porid;
	ID		t_tskid_abort;	/* ü׵ID */
	ID		t_tskid_normal;	/* ̾׵᥿ID */
	VP		t_mapaddr;	/* ޥåפƤ륻ؤΥݥ */
	W		t_mapsect;	/* ߥޥåפƤ륻 */
	W		t_mapstart;	/* ޥåפ򳫻Ϥ륻ֹ */

	/* vdctl */
	BOOL		c_attach;	/* ۥܥ塼 */
	BOOL		c_respstage;	/* ޥɡ쥹ݥ󥹥ơ */
	DevDef		c_devdef;
	DiskInfo	c_diskinfo;
	ID		c_devid;
	ID		c_flgid;
	ID		c_porid;
	ID		c_tskid_abort;	/* ü׵᥿ID */
	ID		c_tskid_normal;	/* ̾׵᥿ID */
	TMO		c_cmdtmo;	/* ޥԤ(ms) */
	TMO		c_resptmo;	/* 쥹ݥԤ(ms) */
	VDCTL_HDR	c_hdr;		/* ޥ¸ѥХåե */
	VP		c_bufaddr;	/* ޥåץХåե */
	W		c_mapmax;	/* ޥåץХåեΥ(sector) */
} DrvWork;

#define	FLAG_COMMAND	0x0001
#define	FLAG_RESPONSE	0x0002

#define	CTLTASK_PRI	80
#define	CTLTASK_STKSZ	3072

#define	VDTASK_PRI	80
#define	VDTASK_STKSZ	3072

#define	MAXDRIVE	1

/* main.c */
IMPORT	ERR	taskspace_select(DevReq *q);

/* vdctl.c */
IMPORT	ERR	ctl_abort(DrvWork *wk, ID tskid);
IMPORT	ERR	ctl_start(DrvWork *wk);
IMPORT	ERR	ctl_finish(DrvWork *wk);
IMPORT	ERR	ctl_mapsect(DrvWork *wk, W start, VP *addr, W size);
IMPORT	ERR	ctl_eject(DrvWork *wk);

/* vddrv.c */
IMPORT	ERR	vd_start(DrvWork *wk);
IMPORT	ERR	vd_finish(DrvWork *wk);

/* getmbfid.c */
IMPORT	WERR	get_mbfid(VOID);
